require "import"
import "android.widget.*"
import "java.io.BufferedWriter"
import "java.io.FileWriter"
import "java.io.IOException"
import "android.content.Context"
import "android.content.Intent"
import "java.util.Locale"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"

local file_path = "/storage/emulated/0/解说/Plugins/Voice caller/Contact.lua"

-- Check if the file exists
local file = io.open(file_path, "r")
if file then
-- File exists
file:close()

package.loaded["Contact"] = nil
local numberTable = require"Contact"
local save_contact_window = require"save_contact_window"
local contact_window = require"contact_window"
local voice = require"voice"

function hasInternetConnection()
local connectivityManager = this.getSystemService(Context.CONNECTIVITY_SERVICE)
local networkInfo = connectivityManager.getActiveNetworkInfo()
return networkInfo ~= nil and networkInfo.isConnected()
end

function startListening()
if not hasInternetConnection() then
  service.speak("இணைய இணைப்பை சரி பார்க்கவும்")
  return false
end

local verbalizationDetected = false
local recognizedName = ""

speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)

speechListener = RecognitionListener{
  onResults = function(results)
    data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
    if data ~= nil and data.size() > 0 then
      verbalizationDetected = true
      recognizedName = data.get(0)

      local number = numberTable[recognizedName]
      if number ~= nil then
        service.callPhone(number)
        return true
       else
save_contact_window()
        end
      end
    end
  }

  recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
  recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
  recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ta_IN")
  recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())

  speechRecognizer.startListening(recognizerIntent)
  speechRecognizer.setRecognitionListener(speechListener)

  return true
end

startListening()
return true
else
-- File does not exist
local sourceFile = '/storage/emulated/0/解说/Plugins/Voice caller/Empty.txt'
local targetFile = '/storage/emulated/0/解说/Plugins/Voice caller/Contact.lua'

-- Open the source file in read mode
local source = io.open(sourceFile, 'r')
if not source then
    print('Failed to open source file:', sourceFile)
    return
end

-- Read the content of the source file
local content = source:read('*all')

-- Close the source file
source:close()

local target = io.open(targetFile, 'w')
if not target then
print('Failed to open target file:', targetFile)
return
end

-- Write the content to the target file
target:write(content)

-- Close the target file
target:close()

        layout = {
          LinearLayout;
          orientation = "vertical";

}
          dlg = LuaDialog(service)
dlg.setButton("cancel",nil)
dlg.setTitle("பூபாலன் பாலகிருஷ்ணன் உருவாக்கிய நீட்டிப்பிற்கு தங்களை அன்புடன் வரவேற்கிறோம்")
          dlg.View = loadlayout(layout)
          dlg.show()
end